=== debian/changelog ===
serioussamclassic-vk (1.10.6-1) jammy; urgency=medium

  * Initial release

 -- YOUR_NAME <YOUR_EMAIL>  Tue, 16 Oct 2023 23:37:15 +0300
